<script>

  import { beforeUpdate } from 'svelte';

  export let setApp   = null;
  export let number   = '';
  export let contacts = [];

  export let _contacts = [];

  beforeUpdate(() => {
    _contacts = contacts.slice(0).sort((a, b) => a.name.localeCompare(b.name));
  });

</script>

<style>

  .scrollable::-webkit-scrollbar {
    width: 8px;
  }
  
  .scrollable::-webkit-scrollbar-thumb {
    background: #666;
  }

  .scrollable::-webkit-scrollbar-track {
    background: #ddd;
  }

  .app-contacts {
    width: calc(100% - 8px);
    height: 100%;
  }

  .contacts {
    overflow-y: auto;
    display: flex;
    flex-direction: row;
  }

  .contact {
    height: 32px;
    background-color: rgba(50, 50, 50, 0.5);
    padding: 8px;
    margin: 8px;
    line-height: 32px;
    color: #e8e8e8;
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    user-select: none;
  }

  .contact:hover {
    background-color: rgba(100, 100, 100, 0.5);
  }

  .contact > div {
    flex-basis: calc(100% / 3);
  }

  .contact .name {
    align-self: flex-start;
  }

  .contact .number {
    text-align: center;
  }

  .contact.me {
    font-weight: bold;
  }

  .contact .actions {
    align-self: flex-end;
    display: flex;
    flex-direction: row;
    justify-content: space-around;
    width: 25%;
    line-height: 32px;
  }

  .contact.add {
    text-align: center;
  }

  .contact.add div {
    flex-basis: 100%;
  }

  .action-edit:hover li {
    color: #bdb54d;
  }

  .action-message:hover li {
    color: #2190b1;
  }

  .action-call:hover li {
    color: #0e8618;
  }

</style>

<div class="app-contacts scrollable">

  <div class="contact me">
    <div class="name"></div>
    <div class="number">{number}</div>
    <div class="actions"></div>
  </div>

  <div class="contact add" on:mouseup={e => setApp('contact', {contact: null})}>
    <div><li class="fas fa-plus"></li></div>
  </div>

  {#each _contacts as contact, index}
    <div class="contact">
      <div class="name">{contact.name}</div>
      <div class="number">#{contact.number}</div>
      <div class="actions">
        <div class="action action-edit" on:mouseup={e => setApp('contact', {contact, index})}><li class="fas fa-pen"></li></div>
        <div class="action action-message" on:mouseup={e => setApp('messagethread', {target: contact.number})}><li class="fas fa-comment-alt"></li></div>
        <div class="action action-call" on:mouseup={e => setApp('outgoingcall', {to: contact.number})}><li class="fas fa-phone"></li></div>
      </div>
    </div>
  {/each}

</div>